---
title: Create Digital Wallet
description: The POST {{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/digitalWallets operation creates a digital wallet for the specified user in the specified environment.
component: pingone-api
page_id: pingone-api:credentials:digital-wallets/create-digital-wallet
canonical_url: https://developer.pingidentity.com/pingone-api/credentials/digital-wallets/create-digital-wallet.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create Digital Wallet

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/digitalWallets
```

The `POST {{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/digitalWallets` operation creates a digital wallet for the specified user in the specified environment.

A request body is required to create a digital wallet.

### Prerequisites

* [Create a user](../../platform/users/users-1/create-user.html) to get a `userID` for the endpoint. Refer also to [Users](../../platform/users.html), especially [User operations](../../platform/users/users-1.html).

* [Create Digital Wallet App](../digital-wallet-apps/create-digital-wallet-app.html) to get a `digitalWalletApplication.id` for the body. Refer also to [Digital Wallets](../digital-wallets.html).

> **Collapse: Request Model**
>
> Refer to [Digital wallet data model](../digital-wallets.html#digital-wallet-data-model) for full property descriptions.
>
> | Property                          | Type      | Required?         |
> | --------------------------------- | --------- | ----------------- |
> | `digitalWalletApplication.id`     | String    | Required          |
> | `applicationInstance.id`          | String    | Optional          |
> | `notification`                    | Object    | Optional          |
> | `notification.template`           | Object    | Optional          |
> | `notification.template.locale`    | String    | Required          |
> | `notification.template.variant`   | String    | Required          |
> | `notification.template.variables` | Object\[] | Required/Optional |

After receipt of this request, the digital wallet service uses the `digital_wallet_pairing` notification template to send the pairing session URL to the user via email or SMS text. The `notification.template` object can define a variant and locale for the notification, if needed.

|   |                                                                                                                                                                                                        |
| - | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
|   | You must include a `notification` object in this create request if you want to use a custom notification template. You cannot use [Update Digital Wallet](update-digital-wallet.html) to add it later. |

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "digitalWalletApplication": {
        "id": "{{digitalWalletApplicationID}}"
    },
    "notification": {
        "methods": [
            "EMAIL",
            "SMS"
        ],
        "template": {
            "locale": "en",
            "variant": "variant_B",
            "variables": {}
        }
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/digitalWallets' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "digitalWalletApplication": {
        "id": "{{digitalWalletApplicationID}}"
    },
    "notification": {
        "methods": [
            "EMAIL",
            "SMS"
        ],
        "template": {
            "locale": "en",
            "variant": "variant_B",
            "variables": {}
        }
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/digitalWallets")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""digitalWalletApplication"": {" + "\n" +
@"        ""id"": ""{{digitalWalletApplicationID}}""" + "\n" +
@"    }," + "\n" +
@"    ""notification"": {" + "\n" +
@"        ""methods"": [" + "\n" +
@"            ""EMAIL""," + "\n" +
@"            ""SMS""" + "\n" +
@"        ]," + "\n" +
@"        ""template"": {" + "\n" +
@"            ""locale"": ""en""," + "\n" +
@"            ""variant"": ""variant_B""," + "\n" +
@"            ""variables"": {}" + "\n" +
@"        }" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/digitalWallets"
  method := "POST"

  payload := strings.NewReader(`{
    "digitalWalletApplication": {
        "id": "{{digitalWalletApplicationID}}"
    },
    "notification": {
        "methods": [
            "EMAIL",
            "SMS"
        ],
        "template": {
            "locale": "en",
            "variant": "variant_B",
            "variables": {}
        }
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/users/{{userID}}/digitalWallets HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "digitalWalletApplication": {
        "id": "{{digitalWalletApplicationID}}"
    },
    "notification": {
        "methods": [
            "EMAIL",
            "SMS"
        ],
        "template": {
            "locale": "en",
            "variant": "variant_B",
            "variables": {}
        }
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"digitalWalletApplication\": {\n        \"id\": \"{{digitalWalletApplicationID}}\"\n    },\n    \"notification\": {\n        \"methods\": [\n            \"EMAIL\",\n            \"SMS\"\n        ],\n        \"template\": {\n            \"locale\": \"en\",\n            \"variant\": \"variant_B\",\n            \"variables\": {}\n        }\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/digitalWallets")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/digitalWallets",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "digitalWalletApplication": {
      "id": "{{digitalWalletApplicationID}}"
    },
    "notification": {
      "methods": [
        "EMAIL",
        "SMS"
      ],
      "template": {
        "locale": "en",
        "variant": "variant_B",
        "variables": {}
      }
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/digitalWallets',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "digitalWalletApplication": {
      "id": "{{digitalWalletApplicationID}}"
    },
    "notification": {
      "methods": [
        "EMAIL",
        "SMS"
      ],
      "template": {
        "locale": "en",
        "variant": "variant_B",
        "variables": {}
      }
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/digitalWallets"

payload = json.dumps({
  "digitalWalletApplication": {
    "id": "{{digitalWalletApplicationID}}"
  },
  "notification": {
    "methods": [
      "EMAIL",
      "SMS"
    ],
    "template": {
      "locale": "en",
      "variant": "variant_B",
      "variables": {}
    }
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/digitalWallets');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "digitalWalletApplication": {\n        "id": "{{digitalWalletApplicationID}}"\n    },\n    "notification": {\n        "methods": [\n            "EMAIL",\n            "SMS"\n        ],\n        "template": {\n            "locale": "en",\n            "variant": "variant_B",\n            "variables": {}\n        }\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/digitalWallets")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "digitalWalletApplication": {
    "id": "{{digitalWalletApplicationID}}"
  },
  "notification": {
    "methods": [
      "EMAIL",
      "SMS"
    ],
    "template": {
      "locale": "en",
      "variant": "variant_B",
      "variables": {}
    }
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"digitalWalletApplication\": {\n        \"id\": \"{{digitalWalletApplicationID}}\"\n    },\n    \"notification\": {\n        \"methods\": [\n            \"EMAIL\",\n            \"SMS\"\n        ],\n        \"template\": {\n            \"locale\": \"en\",\n            \"variant\": \"variant_B\",\n            \"variables\": {}\n        }\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/digitalWallets")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/users/49825b76-e1df-4cdc-b973-0c580f1cb049/digitalWallets/46e7018d-b2d5-482f-a44c-3fa9dd34e7d9"
        },
        "appOpen": {
            "href": "https://credentials.customer.com?u=https%3A%2F%2Fapi.pingone.com%2Fv1%2Fdistributedid%2Frequests%2F4766467d-2dd8-4cba-a9b7-10ba09b97354"
        },
        "qrUrl": {
            "href": "https://api.pingone.com/v1/distributedid/requests/4766467d-2dd8-4cba-a9b7-10ba09b97354"
        }
    },
    "id": "46e7018d-b2d5-482f-a44c-3fa9dd34e7d9",
    "createdAt": "2023-02-10T14:46:24.669Z",
    "updatedAt": "2023-02-10T14:46:24.669Z",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "user": {
        "id": "49825b76-e1df-4cdc-b973-0c580f1cb049"
    },
    "digitalWalletApplication": {
        "id": "9f698462-21d5-4fd6-8599-c2b56683eb57"
    },
    "status": "PAIRING_REQUIRED",
    "pairingSession": {
        "id": "37d2b506-0ea7-4697-8884-c66ada3f4c48",
        "createdAt": "2023-02-10T14:46:24.669Z",
        "updatedAt": "2023-02-10T14:46:24.669Z",
        "environment": {
            "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "user": {
            "id": "49825b76-e1df-4cdc-b973-0c580f1cb049"
        },
        "digitalWallet": {
            "id": "46e7018d-b2d5-482f-a44c-3fa9dd34e7d9"
        },
        "challenge": "48p16h6eouv734ob",
        "qrUrl": "https://api.pingone.com/v1/distributedid/requests/4766467d-2dd8-4cba-a9b7-10ba09b97354",
        "status": "INITIAL"
    },
    "notification": {
        "methods": [
            "EMAIL",
            "SMS"
        ],
        "template": {
            "locale": "en",
            "variant": "variant_B"
        },
        "results": [
            {
                "method": "EMAIL",
                "sent": true,
                "notification": {
                    "id": "00a9e836-c339-4763-ab69-fcd3aa9c5417"
                }
            },
            {
                "method": "SMS",
                "sent": false,
                "error": {
                    "id": "17c006ef-9e5f-443b-b883-86f0855aa936",
                    "code": "INVALID_DATA",
                    "message": "The request could not be completed. One or more validation errors were in the request.",
                    "details": [
                        {
                            "code": "INVALID_VALUE",
                            "message": "Could not find phone attribute for user 49825b76-e1df-4cdc-b973-0c580f1cb049."
                        }
                    ]
                }
            }
        ]
    }
}
```
